#include <stdio.h>
#include <math.h>

#define SCALE	      2
maxmin_(xx, n,  xmin, xmax, xmean)
float   xx[];
int     n;
float	*xmin, *xmax, *xmean;
{
	int	i;
	
	*xmin = xx[0];
	*xmax = xx[0];
	*xmean = xx[0] / n;
	for(i = 1; i < n; i++)
	{
		if(xx[i] > *xmax)
			*xmax = xx[i];
		if(xx[i] < *xmin)
			*xmin = xx[i];
		*xmean += xx[i] / n;
	}
}	
find_m_indx_(xx, n, nmin, nmax)
float xx[];
int   n;
int   *nmin;
int   *nmax;
{
   int nc;
   float  xmin, xmax;
 
   xmin = xx[0];
   xmax = xx[0]; 
   *nmin = 1;
   *nmax = 1;
   for(nc = 1; nc < n; nc++)
   {
      if(xx[nc] > xmax)
      {
         xmax = xx[nc];
         *nmax = nc + 1;
      }
      if(xx[nc] < xmin)
      {
         xmin = xx[nc];
         *nmin = nc + 1;
      }
   }
}
rmean_(xx, n, xmean)
float    xx[], *xmean;
int      n;
{
   int      i;
   float     xmin, xmax;
   
   maxmin_(xx, n, &xmin, &xmax, xmean);
   for(i = 0; i < n; i++)
      xx[i] -= *xmean;
}
normal_(xx, n)
float  *xx;
int    n;
{
   float xmax, xmin, xmean, w;
   int   i;

   rmean_(xx, n, &xmean);
   maxmin_(xx, n, &xmin, &xmax, &xmean);
   w = ((-xmin) > xmax) ? (-xmin) : xmax;
   for( i = 0; i < n; i++)
   {
      if(w != 0.)
         xx[i] = xx[i] / w;
   }
}
